import dori.jasper.engine.*;
import dori.jasper.engine.data.JRBeanCollectionDataSource;
import dori.jasper.engine.export.JRHtmlExporter;
import dori.jasper.engine.export.JRHtmlExporterParameter;
import dori.jasper.engine.export.JRXlsExporter;
import dori.jasper.engine.export.JRXlsExporterParameter;

import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * HelloTv
 */
public class HelloApp {
	/**
	 * C
	 */
	public static void main(String[] args) throws Exception {
		
		// t@C
		String name = "Hello";
		
		// RpC
		System.out.print("[compile]");
		JasperReport jasperReport = JasperCompileManager.compileReport(name + ".xml");
		System.out.println("OK!");
		
		// JasperPrintIuWFNg̐
		// ̃IuWFNg|[ǧɂȂ܂B
		System.out.print("[fill]");
		JRReportFont reportFont = jasperReport.getFonts()[0];
		reportFont.setSize(16);
		Map parameters = new HashMap();
		parameters.put("ReportTitle", "Hello JasperReport!!"); // p[^
		JasperPrint jasperPrint = JasperFillManager.fillReport(jasperReport, parameters, (JRDataSource) null);
		System.out.println("OK!");
		
		// v^ň
		System.out.print("[Print]");
		JasperPrintManager.printReport(jasperPrint, true);
		System.out.println("OK!");
		
		// PDFt@C̏o
		System.out.print("[PDF]");
		JasperExportManager.exportReportToPdfFile(jasperPrint, name + ".pdf");
		System.out.println("OK!");

		// HTMLt@C̏o
		System.out.print("[HTML]");
		JRHtmlExporter htmlExporter = new JRHtmlExporter();
		htmlExporter.setParameter(JRExporterParameter.JASPER_PRINT, jasperPrint);
		htmlExporter.setParameter(JRExporterParameter.OUTPUT_WRITER, new OutputStreamWriter(new FileOutputStream(name + ".html"), "UTF-8"));
		htmlExporter.setParameter(JRXlsExporterParameter.IS_ONE_PAGE_PER_SHEET, Boolean.TRUE);
		htmlExporter.setParameter(JRHtmlExporterParameter.IS_OUTPUT_IMAGES_TO_DIR, Boolean.TRUE);
		htmlExporter.setParameter(JRHtmlExporterParameter.IMAGES_DIR_NAME, "images");
		htmlExporter.setParameter(JRHtmlExporterParameter.IMAGES_URI, "images/");
		htmlExporter.exportReport();
		System.out.println("OK!");
		
		// Excelt@C̏o
		System.out.print("[EXCEL]");
		JRXlsExporter exporter = new JRXlsExporter();
		exporter.setParameter(JRExporterParameter.JASPER_PRINT, jasperPrint);
		exporter.setParameter(JRExporterParameter.OUTPUT_FILE_NAME, name + ".xls");
		exporter.setParameter(JRXlsExporterParameter.IS_ONE_PAGE_PER_SHEET, Boolean.TRUE);
		exporter.exportReport();
		System.out.println("OK!");
		
		System.exit(0);
	}
}
